---
title: CanvasRenderingContext2D.resetTransform()
slug: Web/API/CanvasRenderingContext2D/resetTransform
tags:
  - Canvas
  - CanvasRenderingContext2D
  - Experimental
  - Method
  - Reference
---
<div>{{APIRef}} {{SeeCompatTable}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.resetTransform()</code></strong> method of the Canvas 2D API resets the current transform to the identity matrix.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.resetTransform();
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Resetting_the_matrix">Resetting the matrix</h3>

<p>This example draws a rotated rectangle after modifying the matrix, and then resets the matrix using the <code>resetTransform()</code> method.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>The {{domxref("CanvasRenderingContext2D.rotate()", "rotate()")}} method rotates the transformation matrix by 45°. The {{domxref("CanvasRenderingContext2D.fillRect()", "fillRect()")}} method draws a filled rectangle, adjusted according to that matrix.</p>

<pre class="brush: js; highlight:[9]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Draw a rotated rectangle
ctx.rotate(45 * Math.PI / 180);
ctx.fillRect(60, 0, 100, 30);

// Reset transformation matrix to the identity matrix
ctx.resetTransform();
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Resetting_the_matrix', 700, 180) }}</p>

<h3 id="Continuing_with_a_regular_matrix">Continuing with a regular matrix</h3>

<p>Whenever you're done drawing transformed shapes, you should call <code>resetTransform()</code> before rendering anything else. In this example, the first two shapes are drawn with a skew transformation, and the last two are drawn with the identity (regular) transformation.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js; highlight:[11]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Skewed rectangles
ctx.transform(1, 0, 1.7, 1, 0, 0);
ctx.fillStyle = 'gray';
ctx.fillRect(40, 40, 50, 20);
ctx.fillRect(40, 90, 50, 20);

// Non-skewed rectangles
ctx.resetTransform();
ctx.fillStyle = 'red';
ctx.fillRect(40, 40, 50, 20);
ctx.fillRect(40, 90, 50, 20);</pre>

<h4 id="Result_2">Result</h4>

<p>The <span style="color: gray;">skewed rectangles are gray</span>, and the <span style="color: red;">non-skewed rectangles are red</span>.</p>

<p>{{ EmbedLiveSample('Continuing_with_a_regular_matrix', 700, 180) }}</p>

<h2 id="Polyfill">Polyfill</h2>

<p>You can also use the {{domxref("CanvasRenderingContext2D.setTransform()", "setTransform()")}} method to reset the current transform to the identity matrix, like so:</p>

<pre class="brush: js">ctx.setTransform(1, 0, 0, 1, 0, 0);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-resettransform", "CanvasRenderingContext2D.resetTransform")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.resetTransform")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
</ul>
